﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;
using System.Xml;
using System.Xml.Serialization;


namespace Winform4
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void mnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void toolStripContainer1_ContentPanel_Load(object sender, EventArgs e)
        {

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            tableLayoutPanel1.Dock = DockStyle.Fill;
            textBox1.Dock = DockStyle.Fill;
            listBox1.Dock = DockStyle.Fill;

        }

        private void bnABC_Click(object sender, EventArgs e)
        {
            int index;
            ABC[] abc = new ABC[26];
            for (int i = 0; i < abc.Length; i++)
            {
                abc[i] = new ABC( (char) (i+65)  );
            }
            String s = textBox1.Text.ToUpper().Trim();
            foreach (char ch in s) {
                index = ((int)ch) - 65;
                if (index >= 0 && index <= 25)
                {
                    abc[index].inc();
                }
            }
            listBox1.Items.Clear();
            for (int i = 0; i < abc.Length; i++)
            {
                if (abc[i].Summe > 0)
                {
                    listBox1.Items.Add(abc[i]);
                }
            }
        }

        private void öffnenToolStripButton_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Filter =
               "cs files (*.cs)|*.cs|All files (*.*)|*.*";
            openFileDialog1.FilterIndex = 1;// zählt von 1 !
            openFileDialog1.DefaultExt = ".cs";
            openFileDialog1.InitialDirectory = System.Environment.CurrentDirectory;
            openFileDialog1.Multiselect = false;
            openFileDialog1.RestoreDirectory = true;
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                // Verarbeitung
                string sFile = openFileDialog1.FileName.ToString();
                textBox1.Text = sFile;
                load(sFile);
            }
        }

        private void load(String sFilename)
        {
            textBox1.Text = File.ReadAllText(sFilename);
            /*
            FileStream inFile = new FileStream(sFilename, FileMode.Open);

            StreamReader inStream = new StreamReader(inFile);

            textBox1.Text = inStream.ReadToEnd();

            inStream.Close();
            inFile.Close();
             * */
        }

        private void speichernToolStripButton_Click(object sender, EventArgs e)
        {
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.Filter =
               "txt files (*.txt)|*.txt|pdf files (*.pdf)|*.pdf|All files (*.*)|*.*";
            saveFileDialog1.FilterIndex = 1;// zählt von 1 !
            saveFileDialog1.DefaultExt = ".txt";
            saveFileDialog1.InitialDirectory = System.Environment.CurrentDirectory;
            saveFileDialog1.RestoreDirectory = true;
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                string sFile = saveFileDialog1.FileName.ToString();
                save(sFile);
            }

        }
        private void save(String sFilename)
        {
            File.WriteAllText(sFilename,textBox1.Text);
        }

        private void mnExportErgebnisse_Click(object sender, EventArgs e)
        {
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.Filter =
               "xml files (*.xml)|*.xml|All files (*.*)|*.*";
            saveFileDialog1.FilterIndex = 1;// zählt von 1 !
            saveFileDialog1.DefaultExt = ".txt";
            saveFileDialog1.InitialDirectory = System.Environment.CurrentDirectory;
            saveFileDialog1.RestoreDirectory = true;
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                string sFile = saveFileDialog1.FileName.ToString();
                export(sFile);
            }
        }

        private void export(String sFilename)
        {
            List<ABC> liste = new List<ABC>();
            ABC abc;
            for (int i = 0; i < listBox1.Items.Count; i++)
            {
                abc = (ABC) listBox1.Items[i];
                liste.Add(abc);
            }

            TextWriter tout = new StreamWriter(sFilename);
            XmlSerializer xout = new XmlSerializer(liste.GetType());

            xout.Serialize(tout, liste);
            tout.Flush();
            tout.Close();
        }

        private void mnExport2Excel_Click(object sender, EventArgs e)
        {
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.Filter =
               "xls files (*.xls)|*.xls|All files (*.*)|*.*";
            saveFileDialog1.FilterIndex = 1;// zählt von 1 !
            saveFileDialog1.DefaultExt = ".xls";
            saveFileDialog1.InitialDirectory = System.Environment.CurrentDirectory;
            saveFileDialog1.RestoreDirectory = true;
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                string sFile = saveFileDialog1.FileName.ToString();
                export2Excel(sFile);
            }

        }

        void export2Excel(String sFilename)
        {
            ABC abc;
            CExport2EXCEL exportexcel = new CExport2EXCEL(sFilename);
            exportexcel.openFile();

            for (int i = 0; i < listBox1.Items.Count; i++)
            {
                abc = (ABC)listBox1.Items[i];
                //liste.Add(abc);
                exportexcel.Write(1, i + 1, abc.Zeichen);   // col row double
                exportexcel.Write(2, i + 1, abc.Summe);   // col row double
            }
            exportexcel.closeFile();
        }

       
    }
}
